
//  Etsikorvaa.cs  (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-02-06  Tiedosto luotu.
//  2005-02-06  Viimeisin muutos.

using System ;
using System.IO ;           // Luokat tiedostojen kasittelyyn.
using System.Collections ;  // ArrayList-luokka yms.

class Etsikorvaa
{
   static void
   talleta_tekstirivit_tiedostoon( ArrayList annettu_taulukko_tekstiriveja,
                                   string    annettu_tiedoston_nimi )
   {
      try
      {
         StreamWriter output_tiedosto  = 
                          new  StreamWriter( annettu_tiedoston_nimi ) ;

         for ( int rivin_indeksi  =  0 ;
                   rivin_indeksi  <  annettu_taulukko_tekstiriveja.Count ;
                   rivin_indeksi  ++ )
         {
            output_tiedosto.WriteLine(
                          annettu_taulukko_tekstiriveja[ rivin_indeksi ] ) ;
         }

         output_tiedosto.Close() ;
      }
      catch ( Exception )
      {
         Console.Write( "\n\n Ei voi kirjoittaa tiedostoon \""
                     +  annettu_tiedoston_nimi  +  "\"\n" ) ;
      }
   }


   static void korvaa_stringi_tiedostossa( string  alkuperainen_tiedoston_nimi,
                                           string  korvattava_stringi,
                                           string  korvaava_stringi )
   {
      try
      {
         StreamReader alkuperainen_tiedosto  =  new StreamReader(
                                                alkuperainen_tiedoston_nimi ) ;
         ArrayList  alkuperaiset_tekstirivit  =  new  ArrayList() ;
         ArrayList  muutetut_tekstirivit      =  new  ArrayList() ;

         int  rivilaskuri  =  0 ;
         bool tiedoston_loppu_kohdattu  =  false ;

         while ( tiedoston_loppu_kohdattu  ==  false )
         {
            string tekstirivi_tiedostosta = alkuperainen_tiedosto.ReadLine() ;

            if ( tekstirivi_tiedostosta  ==  null )
            {
               tiedoston_loppu_kohdattu  =  true ;
            }
            else
            {
               rivilaskuri  ++ ;
               alkuperaiset_tekstirivit.Add( tekstirivi_tiedostosta ) ;

               if ( tekstirivi_tiedostosta.IndexOf( korvattava_stringi ) != -1)
               {
                  tekstirivi_tiedostosta  =
                       tekstirivi_tiedostosta.Replace( korvattava_stringi,
                                                       korvaava_stringi ) ;

                  Console.Write( "\n \""  +  korvattava_stringi
                       +  "\" korvattu stringilla \""  +  korvaava_stringi
                       +  "\" rivilla "  +  rivilaskuri  ) ;
               }

               muutetut_tekstirivit.Add( tekstirivi_tiedostosta ) ;
            }
         }

         alkuperainen_tiedosto.Close() ;

         string  backup_tiedoston_nimi  =
                              alkuperainen_tiedoston_nimi  +  ".bak" ;

         talleta_tekstirivit_tiedostoon( alkuperaiset_tekstirivit,
                                         backup_tiedoston_nimi   ) ; 
         talleta_tekstirivit_tiedostoon( muutetut_tekstirivit,
                                         alkuperainen_tiedoston_nimi ) ;
      }
      catch ( FileNotFoundException )
      {
         Console.Write( "\n " + alkuperainen_tiedoston_nimi + " ei aukea." ) ;
      }
   }


   static void Main( string[] komentoriviparametrit )
   {
      string  kayttajan_antama_tiedoston_nimi ;
      string  korvattava_stringi ;
      string  korvaava_stringi ;

      if ( komentoriviparametrit.Length  ==  3 )
      {
         kayttajan_antama_tiedoston_nimi  =  komentoriviparametrit[ 0 ] ;
         korvattava_stringi               =  komentoriviparametrit[ 1 ] ;
         korvaava_stringi                 =  komentoriviparametrit[ 2 ] ;
      }
      else
      {
         Console.Write( "\n Tama ohjelma korvaa stringin teksti- "
                     +  "\n tiedostossa. Anna tiedoston nimi :  " ) ;

         kayttajan_antama_tiedoston_nimi  =  Console.ReadLine() ;

         Console.Write( "\n Anna korvattava stringi: " ) ;
         korvattava_stringi    =  Console.ReadLine() ;

         Console.Write( "\n Anna korvaava stringi:   " ) ;
         korvaava_stringi   =  Console.ReadLine() ;
      }

      if ( korvattava_stringi  ==  ""  ||
           korvattava_stringi  ==  korvaava_stringi )
      {
         Console.Write( "\n Ei voi korvata  \""  +  korvattava_stringi
              +  "\" --> \""  +  korvaava_stringi  +  "\"\n\n" ) ;
      }
      else
      {
         korvaa_stringi_tiedostossa( kayttajan_antama_tiedoston_nimi,
                                     korvattava_stringi,
                                     korvaava_stringi ) ;
      }
   }
}



